/**CHeaderFile*****************************************************************

  FileName    [bmc.h]

  PackageName [bmc]

  Synopsis    [bounded model checking (BMC) header file.]

  Description []

  Author      [Mohammad Awedh]

  Copyright   [This file was created at the University of Colorado at Boulder.
  The University of Colorado at Boulder makes no warranty about the suitability
  of this software for any purpose.  It is presented on an AS IS basis.]

  Revision    [$Id: bmc.h,v 1.8 2002/09/21 03:02:21 awedh Exp $]

******************************************************************************/

#ifndef _BMC
#define _BMC

/*---------------------------------------------------------------------------*/
/* Nested includes                                                           */
/*---------------------------------------------------------------------------*/
#include "ntk.h"
#include "ntmaig.h"
#include "ctlspInt.h"
#include "mcInt.h"

/*---------------------------------------------------------------------------*/
/* Constant declarations                                                     */
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
/* Type declarations                                                         */
/*---------------------------------------------------------------------------*/

typedef struct BmcOption     BmcOption_t;
typedef struct BmcCnfClauses BmcCnfClauses_t;
typedef struct BmcCnfStates  BmcCnfStates_t; 
/**AutomaticStart*************************************************************/

/*---------------------------------------------------------------------------*/
/* Function prototypes                                                       */
/*---------------------------------------------------------------------------*/

EXTERN void Bmc_AbstractCheckAbstractPath(Ntk_Network_t *network, McPath_t *abstractPath, array_t *supportList);
EXTERN void Bmc_CheckLTLFormula(Ntk_Network_t *network, Ctlsp_Formula_t *ltlFormula, BmcOption_t *options, st_table *CoiTable);
EXTERN void Bmc_Init(void);
EXTERN void Bmc_End(void);

/**AutomaticEnd***************************************************************/

#endif /* _BMC */
