/**CHeaderFile*****************************************************************

  FileName    [maig.h]

  PackageName [maig]

  Synopsis    [multi-valued AND/INVERTER graph]

  Description []

  SeeAlso     []

  Author      [Mohammad Awedh]

  Copyright [This file was created at the University of Colorado at
  Boulder.  The University of Colorado at Boulder makes no warranty
  about the suitability of this software for any purpose.  It is
  presented on an AS IS basis.]

  Revision    [$Id: maig.h,v 1.3 2002/09/08 21:43:40 fabio Exp $]


******************************************************************************/

#ifndef _MAIG
#define _MAIG

#include "util.h"
#include "var_set.h"
#include "baig.h"

/*---------------------------------------------------------------------------*/
/* Constant declarations                                                     */
/*---------------------------------------------------------------------------*/
 
#define mAig_And   bAig_And
#define mAig_Or    bAig_Or
#define mAig_Xor   bAig_Xor
#define mAig_Not   bAig_Not
#define mAig_Eq    bAig_Eq
#define mAig_Then  bAig_Then
#define mAig_Zero  bAig_Zero
#define mAig_One   bAig_One
#define mAig_NULL  bAig_NULL

/*---------------------------------------------------------------------------*/
/* Type declarations                                                         */
/*---------------------------------------------------------------------------*/

typedef struct mAigMvarStruct mAigMvar_t;
typedef struct mAigBvarStruct mAigBvar_t;

typedef bAigEdge_t     mAigEdge_t;
typedef bAig_Manager_t mAig_Manager_t;

/*---------------------------------------------------------------------------*/
/* Macro declarations                                                        */
/*---------------------------------------------------------------------------*/


/**AutomaticStart*************************************************************/

/*---------------------------------------------------------------------------*/
/* Function prototypes                                                       */
/*---------------------------------------------------------------------------*/

EXTERN void mAig_Init(void);
EXTERN void mAig_End(void);
EXTERN array_t * mAig_ArrayDuplicate(array_t *mAigArray);
EXTERN mAig_Manager_t * mAig_initAig(void);
EXTERN void mAig_quit(bAig_Manager_t *manager);
EXTERN bAigEdge_t mAig_EquC(mAig_Manager_t * mgr, mAigEdge_t mVarId, int constant);
EXTERN mAigEdge_t mAig_CreateVar(mAig_Manager_t * mgr, char * name, int value);

/**AutomaticEnd***************************************************************/

#endif /* _MAIG */












