/**CHeaderFile*****************************************************************

  FileName    [maigInt.h]

  PackageName [maig]

  Synopsis    []

  Description [Internal data structures of Multi-vlaued AND/INVERTER package]

  SeeAlso     []

  Author      [Mohammad Awedh]

  Copyright [This file was created at the University of Colorado at
  Boulder.  The University of Colorado at Boulder makes no warranty
  about the suitability of this software for any purpose.  It is
  presented on an AS IS basis.]

  Revision    [$Id: maigInt.h,v 1.3 2002/08/27 23:56:13 fabio Exp $]


******************************************************************************/

#ifndef _MAIGINT
#define _MAIGINT

#include "maig.h"
#include "baigInt.h"
#include "array.h"


/*---------------------------------------------------------------------------*/
/* Constant declarations                                                     */
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
/* Type declarations                                                         */
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
/* Structure declarations                                                    */
/*---------------------------------------------------------------------------*/

/**Struct**********************************************************************

  Synopsis    [Multi-valued Variable]

  Description [This structure stores an information about a Multi-value variable.]

******************************************************************************/
struct mAigMvarStruct {
    int  mVarId;          /* Uniquely identifies this mVar node in mVarList*/
    char *name;	          /* Name of multi-value node */
    int  values;	  /* This mvar takes vlaues from 0 -- values-1 */
    int  encodeLength;    /* Number of binary variables needed to encode this 
                             mvar */
    int  bVars;          /* The array index of the first bVar in the bVarList
                            the size of the binary encoding equal encodeLength
                            and code arrange from  most significant bit to 
                            least significant bit */
};

/**Struct**********************************************************************

  Synopsis    [Binary-valued varaible]

  Description [Thsi structure contians information about binary-vlaue node]

*****************************************************************************/
struct mAigBvarStruct {
    bAigEdge_t node;  /* Binary function of this node in the AndInv graph */
    int mVarId;          /* This bVar node belongs to mVar node mVarId       */
};

/*---------------------------------------------------------------------------*/
/* Type declarations                                                         */
/*---------------------------------------------------------------------------*/


/**AutomaticStart*************************************************************/

/*---------------------------------------------------------------------------*/
/* Function prototypes                                                       */
/*---------------------------------------------------------------------------*/

EXTERN array_t * mAigReadBinVarList(mAig_Manager_t * manager);
EXTERN array_t * mAigReadMulVarList(mAig_Manager_t * manager);

/**AutomaticEnd***************************************************************/

#endif /* _MIGINT */





